set ns [new Simulator] 
 
$ns color 47 red 
$ns color 1 blue 
$ns color 2 green 
$ns color 0 purple 
$ns color 3 orange
 
set nf [open out.nam w]
$ns namtrace-all $nf
set f1 [open out.ns w]
$ns trace-all $f1

set n0 [$ns node] 
set n1 [$ns node] 
set n2 [$ns node]
set n3 [$ns node]

$ns duplex-link $n0 $n1 10Mb 1ms DropTail
$ns duplex-link $n1 $n2 10Mb 1ms DropTail  
$ns duplex-link $n3 $n1 10Mb 1ms DropTail
 
$ns config-nsis-link $n0 $n1 ;#attach a TCpChecker object on the link after the ttl object
$ns config-nsis-link $n1 $n2
$ns config-nsis-link $n3 $n1

$ns nsis-transmission-mode "cmode"
puts "Mode: [$ns set nsis_mode]"
# Enable upcalls on all nodes 
 
Agent/GIMPS set lifetime_ 30
Agent/GIMPS set poolingTime_ 5
Agent/GIMPS set debug_ 0

;#create the GIMPS agents and attach them to the node.
;#the GIMPS agent is returned  
set nsis0 [$n0 add-gimps-agent]  
set nsis1 [$n1 add-gimps-agent] 
set nsis2 [$n2 add-gimps-agent] 
set nsis3 [$n3 add-gimps-agent]


;#connect the following pairs: GIMPS, tcp_, and tcp_sink agents
$ns connect-gimps-agents [$n0 id] [$n1 id]
$ns connect-gimps-agents [$n1 id] [$n2 id]
$ns connect-gimps-agents [$n3 id] [$n1 id]

#set nsis2 [new Agent/GIMPS]
$nsis0 set class_ 0
$nsis1 set class_ 2
$nsis2 set class_ 1
$nsis3 set class_ 3

set app0 [new Application/NSIS]
set app1 [new Application/NSIS]
set app2 [new Application/NSIS]
set app3 [new Application/NSIS]

$app0 attach-agent $nsis0 
$app1 attach-agent $nsis1 
$app2 attach-agent $nsis2
$app3 attach-agent $nsis3

set sesid0 [$app0 session [$n0 id] [$n2 id] 2]

set sesid1 [$app2 session [$n2 id] [$n0 id] 3]

$ns at 1.0 "$app0 sender $sesid0 123"

$ns at 30 "finish" 
 
proc finish {} {
        global ns f1 nf
        $ns flush-trace
	#Close the trace file
        close $nf
	close $f1	 
	#Execute nam on the trace file
        exec nam out.nam &
        exit 0
}
 
$ns run 
