set ns [new Simulator] 
 
$ns color 47 red 
$ns color 1 blue 
$ns color 2 green 
$ns color 0 purple 
$ns color 3 orange
 
set nf [open out.nam w]
$ns namtrace-all $nf
set f1 [open out.ns w]
$ns trace-all $f1

set nleft [$ns node] 
set nright [$ns node] 


$ns duplex-link $nleft $nright 100Mb 1ms DropTail
$ns duplex-link $nleft $nright 100Mb 1ms DropTail  
 
$ns config-nsis-link $nleft $nright ;#attach a TCpChecker object on the link after the ttl object

$ns nsis-transmission-mode "dmode"
#puts "Mode: [$ns set nsis_mode]"
# Enable upcalls on all nodes 
 
Agent/GIMPS set lifetime_ 30
Agent/GIMPS set poolingTime_ 10
Agent/GIMPS set debug_ 0

;#create the GIMPS agents and attach them to the node.
;#the GIMPS agent is returned  
set lgimps [$nleft add-gimps-agent]  
set rgimps [$nright add-gimps-agent] 


;#connect the following pairs: GIMPS, tcp_, and tcp_sink agents
$ns connect-gimps-agents [$nleft id] [$nright id]

#set nsis2 [new Agent/GIMPS]
$nleft set class_ 0
$nright set class_ 1

set appleft [new Application/NSIS]
set appright [new Application/NSIS]

$appleft attach-agent $lgimps 
$appright attach-agent $rgimps

set n 2

if {$argc == 1} { set n $argv }

puts " UDP scenario - Number of nodes at each side: $n"

  for {set l 1} {$l <= $n} {incr l} {
    set node($l) [$ns node] 
    $ns duplex-link $node($l) $nleft 10Mb 0.1s DropTail
    $ns config-nsis-link $node($l) $nleft
    set gimps($l) [$node($l) add-gimps-agent] 
    $ns connect-gimps-agents [$node($l) id] [$nleft id]
    set app($l) [new Application/NSIS]
    $app($l) attach-agent $gimps($l)   
  }
  
  for {set r [expr $n+1]} {$r <= [expr $n*2]} {incr r} {
    
    set node($r) [$ns node]
    $ns duplex-link $node($r) $nright 10Mb 0.1s DropTail
    $ns config-nsis-link $node($r) $nright
    set gimps($r) [$node($r) add-gimps-agent]
    $ns connect-gimps-agents [$node($r) id] [$nright id]
    set app($r) [new Application/NSIS]
    $app($r) attach-agent $gimps($r)
    
  } 
  
  for {set i 1} {$i <= $n} {incr i} { 
    set ri [expr $i+$n]
    set sesid($i) [$app($i) session [$node($i) id] [$node($ri) id] $i] 
    puts "Session ID: $sesid($i)"
}

puts "Scenario created"

set stime 0.1
$ns at $stime "$app(1) sender $sesid(1) 7"
set stime 1
for {set i 2} {$i <= $n} {incr i} {   
   set stime [expr $stime + 0.2]
   $ns at $stime "$app($i) sender $sesid($i) 7"
}

$ns at 80 "finish" 
 
proc finish {} {
        global ns f1 nf
        $ns flush-trace
	#Close the trace file
        close $nf
	close $f1	 
	#Execute nam on the trace file
        #exec nam out.nam &
        exit 0
}
 
$ns run 
