#include "gimps.h"

static class GimpsTcpAppClass : public TclClass {
public:
	GimpsTcpAppClass() : TclClass("Application/TcpApp/Gimps") {}
	TclObject* create(int argc, const char*const* argv) {
		if (argc != 5)
			return NULL;
		Agent *tcp = (Agent *)TclObject::lookup(argv[4]);
		if (tcp == NULL) 
			return NULL;
		return (new GimpsTcpApp(tcp));
	}
} class_gimps_tcp_app;

GimpsTcpApp::GimpsTcpApp(Agent *tcp): TcpApp(tcp) {
	peer_ = next = NULL;
}

void GimpsTcpApp::process_data(int size, AppData *data) {
	unsigned int temp;
	if (data == NULL) {
		gimps_agent_->recv(0);
		return;
	}
	TcpAppString *tmp = (TcpAppString*)data;
	temp = atoi(tmp->str());
	//GIMPSMessage *msg = (GIMPSMessage *)temp;
	//printf("[GimpsTcpApp process_data]<Node %d> Message arrived successfully\n", 
    //msg->getDestinationAddress());
	gimps_agent_->recv(temp);	
}

void GimpsTcpApp::sendmsg(int nbytes, unsigned int data) {
	char d[10];
	GIMPSMessage *msg;
	msg = (GIMPSMessage *)data;
	/*
	printf("[GimpsTcpApp sendmsg]<Node %d> Preparing to send message to node %d\n", 
    msg->getTlvNLI()->(), nbytes, msg->getDestinationAddress()); 
	fflush(stdout);
	*/
	sprintf(d, "%d", data);
	TcpAppString *tmp = new TcpAppString();
	tmp->set_string(d); 
	send(nbytes, tmp);	
}

int GimpsTcpApp::command(int argc, const char*const* argv)
{
	Tcl& tcl = Tcl::instance();

	if (argc == 3) {
		if (strcmp(argv[1], "attach-receiver") == 0) {
			peer_ = (GimpsTcpApp *) TclObject::lookup(argv[2]);
    		if (peer_ == 0)
    		{
      			tcl.resultf("[GimpsTcpApp] no such destination application %s", argv[2]);
      			return(TCL_ERROR);
    		}
    		return(TCL_OK);
		}
	}
	if (argc == 3) {
		if (strcmp(argv[1], "attach-gimps-agent") == 0) {
			gimps_agent_ = (GIMPSAgent *) TclObject::lookup(argv[2]);
    		if (gimps_agent_ == 0)
    		{
      			tcl.resultf("[GimpsTcpApp] no such agent to attach %s", argv[2]);
      			return(TCL_ERROR);
    		}
    		return(TCL_OK);
		}
	}
	return (TcpApp::command(argc, argv));
}

GimpsTcpApp::~GimpsTcpApp(){
}