#ifndef GIMPSTCPAPP_H_
#define GIMPSTCPAPP_H_

#include "webcache/tcpapp.h"
#include "app.h"


class GimpsTcpApp;

class TcpAppString : public AppData {
private:
	int size_;
	char* str_; 
public:
	TcpAppString() : AppData(TCPAPP_STRING), size_(0), str_(NULL) {}
	TcpAppString(TcpAppString& d) : AppData(d) {
		size_ = d.size_;
		if (size_ > 0) {
			str_ = new char[size_];
			strcpy(str_, d.str_);
		} else
			str_ = NULL;
	}
	virtual ~TcpAppString() { 
		if (str_ != NULL) 
			delete []str_; 
	}

	char* str() { return str_; }
	virtual int size() const { return AppData::size() + size_; }

	// Insert string-contents into the ADU
	void set_string(const char* s) {
		if ((s == NULL) || (*s == 0)) 
			str_ = NULL, size_ = 0;
		else {
			size_ = strlen(s) + 1;
			str_ = new char[size_];
			assert(str_ != NULL);
			strcpy(str_, s);
		}
	}
	virtual AppData* copy() {
		return new TcpAppString(*this);
	}
};

class GimpsTcpApp: public TcpApp {
public:
	GimpsTcpApp(Agent *);
	virtual ~GimpsTcpApp();
	virtual void process_data(int size, AppData *data);
	void incRef() { num_ref++; }
	void decRef() { num_ref--; }
	void sendmsg(int nbytes, const char* data);
	GimpsTcpApp *next;
	GIMPSAgent *gimps_agent_;
	int num_ref;
	//virtual void send(int nbytes, AppData *data);
};

#endif /*GIMPSTCPAPP_H_*/
