#
# Copyright (c) 1998 The University of Bonn
# All rights reserved.
# 
# Permission to use and copy this software in source and binary forms
# is hereby granted, provided that the above copyright notice, this
# paragraph and the following disclaimer are retained in any copies
# of any part of this software and that the University of Bonn is
# acknowledged in all documentation pertaining to any such copy
# or derivative work. The name of the University of Bonn may not
# be used to endorse or promote products derived from this software
# without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
# EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE WARRANTIES OF 
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL 
# THE UNIVERSITY OF BONN BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
# WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF 
# OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
# SOFTWARE.
#

Agent/GIMPS set refresh_ 30
#Agent/NSIS set lifetime_factor_ 3
Agent/GIMPS set lifetime_ 30 ;#MRS lifetime
Agent/GIMPS set fid_ 46
Agent/GIMPS set nam_ 1
Agent/GIMPS set messageRoutingMethod_ 1
Agent/GIMPS set nslpid_ 1
Agent/GIMPS set ip6_ 0

Application/NSIS set nslpid_ 1
Application/NSIS set refresh_ 30

NSISLink set src_ -1
NSISLink set dst_ -1
NSISLink set besteffort_ 0
NSISLink set debug_ false

NSISChecker set src_ 0
NSISChecker set debug_ false


# Set the destination for an NSISChecker object
NSISChecker instproc set-dst { node } {
	$self instvar dst_
	set dst_ $node 
}

# Set the source for an NSISChecker object
NSISChecker instproc set-src { node } {
	$self instvar src_
	set src_ [$node id]
}

# Return the destination for an NSISChecker object
NSISChecker instproc get-gimps-agent {} {
	$self instvar dst_		
	return [$dst_ get-gimps-agent]
}

# Return the address of the destination agent for an NSISChecker object
NSISChecker instproc get-gimps-agent-addr {} {
	$self instvar dst_
	set agent [$dst_ get-gimps-agent]
	return [$agent set agent_addr_]
}

Simulator instproc nsis-transmission-mode { mode } {
	$self instvar nsis_mode
        set nsis_mode $mode
}

#Simulator instproc get-transmission-mode {} {
#	$self instvar nsis_mode
#        return [set nsis_mode]
#}

# Add a GIMPS agent to a node
Node instproc add-gimps-agent {} {
	$self instvar nsis_	
	$self instvar tcp_src
	$self instvar tcp_dst					
	set nsis_     [new Agent/GIMPS] 
	$nsis_ set prio_ 7
	;#set nsis_tcp  [new Agent/TCP/TCPNSIS]
 	;#set nsis_sink [new Agent/TCPSink/TCPSinkNSIS]
        [Simulator instance] set nsis_mode
        $nsis_ config-mode [[Simulator instance] set nsis_mode]
  	[Simulator instance] attach-agent $self $nsis_
	;#[Simulator instance] attach-agent $self $nsis_tcp
	;#[Simulator instance] attach-agent $self $nsis_sink		
	#setting IP for gimps layer			
	$nsis_ setipgimps $self
#$nsis_ attach-agent $nsis_tcp  ;#it just pass gimps (nsis_) a reference to the tcp agent!    
        ;#$nsis_ attach-agent-sink $nsis_sink
	$nsis_ start			                 		
	return $nsis_
}

Simulator instproc add-tcp-connection { src dst } {
#set nsis_tcp [new Agent/TCP/TCPNSIS]
#set nsis_sink [new Agent/TCP/TCPNSIS]
        set tcp_src [new Agent/TCP/FullTcp]
        set tcp_dst [new Agent/TCP/FullTcp]        
#set nsis_sink [new Agent/TCPSink/TCPSinkNSIS]
        $tcp_dst listen ;# will figure out who its peer is
        $tcp_src set window_ 100;
        set nsrc [$self get-node-by-id $src] 
        set ndst [$self get-node-by-id $dst]
        $self attach-agent $nsrc $tcp_src
	$self attach-agent $ndst $tcp_dst		
	$self connect $tcp_src $tcp_dst
        
        set app_src [new Application/TcpApp/Gimps]
        set app_dst [new Application/TcpApp/Gimps]        
        set app_src [new Application/TcpApp/Gimps $tcp_src]
        set app_dst [new Application/TcpApp/Gimps $tcp_dst]
#[$ndst get-gimps-agent] attach-app-receiver $app_dst  
        $app_src attach-gimps-agent [$nsrc get-gimps-agent]
        $app_dst attach-gimps-agent [$ndst get-gimps-agent]      
        $app_src connect $app_dst
        $app_src attach-receiver $app_dst
        return $app_src
#$self add-tcp-agent $nsis_tcp
}

# Return a node's NSIS agent (or nothing if there is none)
Node instproc get-gimps-agent {} {
	$self instvar nsis_
	if [info exists nsis_] {
		return $nsis_
	} else {
		return
	}
}

Simulator instproc get-gimps-agent-tcp { n1 } {
	$self instvar tcp_src
       return [[$self get-node-by-id $n1] get-gimps-agent-tcp]
}

Node instproc get-gimps-agent-tcp {} {
	$self instvar tcp_src
	if [info exists tcp_src] {
		return $tcp_src
	} else {
		return
	}
}

Node instproc get-gimps-agent-tcpsink {} {
	$self instvar tcp_dst
	if [info exists tcp_dst] {
		return $tcp_dst
	} else {
		return
	}
}

# Add an NSISChecker object to a link
SimpleLink instproc add-nsis-checker { check } {
	$self instvar nsischeck_ link_ ttl_
	set nsischeck_ $check
}

# Connect two NSIS agents
Simulator instproc connect-gimps-agents { n1 n2 } {
	set a1 [[$self get-node-by-id $n1] get-gimps-agent]
	set a2 [[$self get-node-by-id $n2] get-gimps-agent]
	$self connect $a1 $a2
}

Simulator instproc connect-gimps-agents-tcp { n1 n2 } {
	set a1 [[$self get-node-by-id $n1] get-gimps-agent-tcp]
	set a2 [[$self get-node-by-id $n2] get-gimps-agent-tcpsink]
	$self connect $a1 $a2
		
}

# Set up an NSIS link with an NSISChecker object, admission
# control and a class for the best-effort traffic
Simulator instproc setup-nsis-link { n1 n2 } {
	set link_ [$self link $n1 $n2]
	set ttl_ [$link_ set ttl_]
	set nsischeck_ [new NSISChecker]
	$nsischeck_ set-dst $n2
	$nsischeck_ target [$ttl_ target]
	$ttl_ target $nsischeck_
	$nsischeck_ set-dst $n2
	$nsischeck_ set-src $n1
}

# Create a duplex NSIS link
# Arguments: Node1, Node2, Bandwidth, Delay and queue
Simulator instproc config-nsis-link { n1 n2 } {
#	$self duplex-link $n1 $n2 $bw $delay $queue NSISLink 	
	$self setup-nsis-link $n1 $n2 
	$self setup-nsis-link $n2 $n1 
}

Simulator instproc set-nqueue {nq n1 n2} {

	set nn1 [$self get-node-by-id $n1] 
	set nn2 [$self get-node-by-id $n2] 
	set lnk [$self link $nn1 $nn2]
	set q [$lnk queue]
#	$q set nqueues_ $nq
	$q setNumQueues $nq 
}
