/***************************************************************************
 *   Copyright (C) 2005 by Ribeiro, Romulo Eugenio                         *
 *   romulo@dei.uc.pt                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#include "nsis-objects.h" 

TlvObjectSI::TlvObjectSI(unsigned char *cont)
{
  int cl;
  cl = sizeof(struct objheader) + sizeof(struct construct);
  header = (objheader *)cont;
  contents = new unsigned char[header->conlength];
  memcpy(contents, cont, header->conlength);
  header = (objheader *)contents;
  con = (construct *)(contents + sizeof(struct objheader));
  header->conlength = cl;
  header->length = 32 + 32;
};

TlvObjectSI::TlvObjectSI(int config, int fid_) 
{
  int cl;
  cl = sizeof(struct objheader) + sizeof(struct construct);
  contents = new unsigned char[cl];
  header = (objheader *)contents;
  con = (construct *)(contents + sizeof(struct objheader));
  header->conlength = cl;
  header->aFlag = 0;
  header->bFlag = 0;
  header->length = 32 + 32;
  header->type = TYPE_SESSION_IDENTIFICATION ;
  con->sessionId = config;
  con->fid = fid_;
};

//===================================================  QC ==================
//==========================================================================
char *TlvObjectQC::getQuery()
{
  char *cl = new  char[SIZECOOKIE];
  strcpy(cl,con->query);
  return cl;
};



TlvObjectQC::TlvObjectQC(unsigned char *cont)
{
  int cl;
  cl = sizeof(struct objheader) + sizeof(struct construct);
  header = (objheader *)cont;
  contents = new unsigned char[header->conlength];
  memcpy(contents, cont, header->conlength);
  header = (objheader *)contents;
  con = (construct *)(contents + sizeof(struct objheader));
  header->conlength = cl;
  header->length = 32 + 32;
};


TlvObjectQC::TlvObjectQC()
{
  int cl;
  cl = sizeof(struct objheader) + sizeof(struct construct);
  contents = new unsigned char[cl];
  header = (objheader *)contents;
  con = (construct *)(contents + sizeof(struct objheader));
  header->conlength = cl;
  header->aFlag = 0;
  header->bFlag = 0;
  header->conlength = cl;
  header->length = 32 + 32;
  header->type = TYPE_QUERY_COOKIE;
  this->Generatecookie();
};

//TODO: make real function to generate a cookie...

void TlvObjectQC::Generatecookie()
{
  strncpy(con->query, "0123456789abcdef", sizeof(con->query));
};

//================================================ Query Responder ================
//==================================================================================

TlvObjectRC::TlvObjectRC(unsigned char *cont)
{
  int cl;
  cl = sizeof(struct objheader) + sizeof(struct construct);
  header = (objheader *)cont;
  contents = new unsigned char[header->conlength];
  memcpy(contents, cont, header->conlength);
  header = (objheader *)contents;
  con = (construct *)(contents + sizeof(struct objheader));
  header->conlength = cl;
  header->length = 32 + 32;
};

TlvObjectRC::TlvObjectRC()
{
  int cl;
  cl = sizeof(struct objheader) + sizeof(struct construct);
  contents = new unsigned char[cl];
  header = (objheader *)contents;
  con = (construct *)(contents + sizeof(struct objheader));
  header->conlength = cl;
  header->aFlag = 0;
  header->bFlag = 0;
  header->conlength = cl;
  header->length = 32 + 32;
  header->type = TYPE_RESPONDER_COOKIE;
  this->Generatecookie();
};

// todo: make real function to generate a cookie...

void TlvObjectRC::Generatecookie()
{
  strcpy(con->responder, "12345678");
};


char *TlvObjectRC::getResponder()
{
  char *cl = new  char[SIZECOOKIE];
  strcpy(cl,con->responder);
  return cl;
};

//=========================================  Lt Object ========================
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


TlvObjectLT::TlvObjectLT (long config)
{
  int cl;
  cl = sizeof(struct objheader) + sizeof(struct construct);
  contents = new unsigned char[cl];
  header = (objheader *)contents;
  con = (construct *)(contents + sizeof(struct objheader));
  header->conlength = cl;
  header->aFlag = 0;
  header->bFlag = 0;
  header->conlength = cl;
  header->length = 32;
  header->type = TYPE_LIFETIME;
  con->lt = config ;
};


TlvObjectLT::TlvObjectLT(unsigned char *cont)
{
  int cl;
  cl = sizeof(struct objheader) + sizeof(struct construct);
  header = (objheader *)cont;
  contents = new unsigned char[header->conlength];
  memcpy(contents, cont, header->conlength);
  header = (objheader *)contents;
  con = (construct *)(contents + sizeof(struct objheader));
  header->conlength = cl;
};

//=========================================  MRI Object ========
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
TlvObjectMRI::TlvObjectMRI (unsigned char *cont)
{
  int cl;
  cl = sizeof(struct objheader) + sizeof(struct construct);
  header = (objheader *)cont;
  contents = new unsigned char[header->conlength];
  memcpy(contents, cont, header->conlength);
  header = (objheader *)contents;
  con = (construct *)(contents + sizeof(struct objheader));
  header->conlength = cl;
  header->length = size();
};

TlvObjectMRI::TlvObjectMRI(int messageRoutingMethod, char ipVer, char pFlag,
 char tFlag, char fFlag, char sFlag, char aFlag, char bFlag, char dFlag, 
 int reservedFlag, nsaddr_t sourceAddress, nsaddr_t destinationAddress, 
 int sourcePrefix, int destinationPrefix, char protocol,  int trafficClass, 
 int reservedFlowLabel, int flowLabel, int spi, int sourcePort, 
 int destinationPort)
{
  int cl;
  cl = sizeof(struct objheader) + sizeof(struct construct);
  contents = new unsigned char[cl];
  header = (objheader *)contents;
  con = (construct *)(contents + sizeof(struct objheader));
  header->conlength = cl;
  header->aFlag = 0;
  header->bFlag = 0;
  header->conlength = cl;
  header->length = size();
  header->type = TYPE_MESSAGE_ROUTING_INFORMATION;
  // Set TLV MRI fields
  con->messageRoutingMethod = messageRoutingMethod;
  con->ipVer = ipVer;
  con->pFlag = pFlag;
  con->tFlag = tFlag;
  con->fFlag = fFlag;
  con->sFlag = sFlag;
  con->dFlag = dFlag;
  con->aFlag = aFlag;
  con->bFlag = bFlag;

  con->reservedFlag = reservedFlag;
  con->sourceAddress = sourceAddress;
  con->destinationAddress = destinationAddress;
  con->sourcePrefix = sourcePrefix;
  con->destinationPrefix = destinationPrefix;
  con->protocol = protocol;
  con->trafficClass = trafficClass;
  con->reservedFlowLabel = reservedFlowLabel;
  con->flowLabel = flowLabel;
  con->spi = spi;
  con->sourcePort = sourcePort;
  con->destinationPort = destinationPort;
};

int TlvObjectMRI::size()
{
  int messageRoutingMethodSize = 16;
  int ipVerSize = 4;
  int flags = 7;
  int reservedFlagSize = 5;
  //IPv4
  int sourceAddressSize = 32;
  int destinationAddressSize = 32;
  int sourcePrefixSize = 8;
  int destinationPrefixSize = 8;
  int protocolSize = 8;
  int trafficClassSize = 8;
  int reservedFlowLabelSize = 12;
  int flowLabelSize = 20;
  int spiSize = 32;
  int sourcePortSize = 16;
  int destinationPortSize = 16;
  int total=0;
  total = messageRoutingMethodSize + ipVerSize + flags +  reservedFlagSize + sourcePrefixSize + 
          sourceAddressSize + destinationAddressSize +
          destinationPrefixSize +protocolSize +trafficClassSize +
          reservedFlowLabelSize + flowLabelSize + spiSize + sourcePortSize + 
          destinationPortSize;
  return total;
}



void TlvObjectMRI::configFlowLabel(int config)
{
  if (config == 0)
    con->fFlag = 0 ;
  else
  {
    con->fFlag = 1;
    con->flowLabel = config;
  };
};


/*
 * Inserts the value to the variable
 */
void TlvObjectMRI::configSpi(int config)
{
  if (config == 0)
    con->sFlag = 0 ;
  else
  {
    con->sFlag = 1;
    con->spi = config;
  };
};

void TlvObjectMRI::configSourcePort(int config)
{
  if(config == 0)
    con->aFlag = 0;
  else
  {
    con->aFlag = 1;
    con->sourcePort = config;
  };
};

void TlvObjectMRI::configDestinationPort(int config)
{
  if (config == 0 )
    con->bFlag = 0;
  else
  {
    con->bFlag = 1;
    con->destinationPort = config;
  };
};


void TlvObjectMRI::configDirection(char config)
{
     con->dFlag = config;
};


char TlvObjectMRI::changeDirection()
{
     con->dFlag = !con->dFlag;
};


char TlvObjectMRI::getDirection()
{
     return con->dFlag;
};

//-----------------------------------------------sp -------------------------------------------------
//---------------------------------------------------------------------------------------------------


TlvObjectSP::TlvObjectSP(unsigned char *cont)
{
  int cl;
  cl = sizeof(struct objheader) + sizeof(struct construct);
  header = (objheader *)cont;
  contents = new unsigned char[header->conlength];
  memcpy(contents, cont, header->conlength);
  header = (objheader *)contents;
  con = (construct *)(contents + sizeof(struct objheader));
  header->conlength = cl;
  header->length = 32+32;
};


TlvObjectSP::TlvObjectSP(int profCount, CHAR32 profiles)
{
  int cl;
  cl = sizeof(struct objheader) + sizeof(struct construct);
  contents = new unsigned char[cl];
  header = (objheader *)contents;
  con = (construct *)(contents + sizeof(struct objheader));
  header->conlength = cl;
  header->aFlag = 0;
  header->bFlag = 0;
  header->conlength = cl;
  header->length = 32+32;
  header->type = TYPE_STACK_PROPOSAL;
  con->profCount = profCount;
  strcpy(con->profiles,profiles);
  con->reserved =0;
};
 
//===================================================  NLI ========================================
//================================================================================================

TlvObjectNLI::TlvObjectNLI(int piLength, int ipTTL, long RSVT, 
            int ipVer, int peerIdentity, nsaddr_t interfaceAddress)
{
  int cl;
  cl = sizeof(struct objheader) + sizeof(struct construct);
  contents = new unsigned char[cl];
  header = (objheader *)contents;
  con = (construct *)(contents + sizeof(struct objheader));
  header->conlength = cl;
  header->aFlag = 0;
  header->bFlag = 0;
  header->conlength = cl;

  header->type = TYPE_NETWORK_INFORMATION_LAYER ;
  con->piLength = piLength;
  con->ipVer = ipVer;
  con->ipTTL = ipTTL;
  con->RSVT = RSVT;
  header->length = /*64* +*/  128 + 32;
  con->peerIdentity = peerIdentity;
  con->interfaceAddress = interfaceAddress;
}

TlvObjectNLI::TlvObjectNLI(unsigned char *cont)
{
  int cl;
  cl = sizeof(struct objheader) + sizeof(struct construct);
  header = (objheader *)cont;
  contents = new unsigned char[header->conlength];
  memcpy(contents, cont, header->conlength);
  header = (objheader *)contents;
  con = (construct *)(contents + sizeof(struct objheader));
  header->conlength = cl;
  header->length = 128 + 32;
};

TlvObjectSCD::TlvObjectSCD(int HLCount, int HLIprotocol, int HLIport)
{
  int cl;
  cl = sizeof(struct objheader) + sizeof(struct construct);
  contents = new unsigned char[cl];
  header = (objheader *)contents;
  con = (construct *)(contents + sizeof(struct objheader));
  header->conlength = cl;
  header->aFlag = 0;
  header->bFlag = 0;
  header->conlength = cl;

  header->type = TYPE_SCD ;
  header->length = 32 + 64;
  con->HLCount = HLCount;
  con->HLIport=0;
  con->HLIprotocol=DATAGRAM;

}


TlvObjectSCD::TlvObjectSCD(unsigned char *cont)
{
  int cl;
  cl = sizeof(struct objheader) + sizeof(struct construct);
  header = (objheader *)cont;
  contents = new unsigned char[header->conlength];
  memcpy(contents, cont, header->conlength);
  header = (objheader *)contents;
  con = (construct *)(contents + sizeof(struct objheader));
  header->conlength = cl;
  header->length = 32 + 64;
};

 


// --------------------------------- object error ------------------------------
//------------------------------------------------------------------------------



TlvObjectERROR::TlvObjectERROR(int errorClass, int errorCode, int esilength, char *errorSourceIdentifier,
                               int opterrorlength, char *optionalErrorSpecificInformation)
{
  int cl;
  cl = sizeof(struct objheader) + sizeof(struct construct) + esilength + opterrorlength;
  contents = new unsigned char[cl];
  header = (objheader *)contents;
  con = (construct *)(contents + sizeof(struct objheader));
  header->conlength = cl;
  header->aFlag = 0;
  header->bFlag = 0;
  header->length = 64 + opterrorlength + esilength;
  header->type = TYPE_ERROR ;
  con->errorClass = errorClass;
  con->errorCode =  errorCode ;
  con->esiLength = esilength;
  con->errorSourceIdentifier = new char [esilength];
  memcpy(con->errorSourceIdentifier,errorSourceIdentifier,esilength);
  con->optionalErrorSpecificInformation = new char[opterrorlength];
  memcpy(con->optionalErrorSpecificInformation,optionalErrorSpecificInformation,opterrorlength);
};


char  *TlvObjectERROR::get_SourceIdentifier()
{
  char *cl = new char[con->esiLength];
  memcpy(cl,con->errorSourceIdentifier,con->esiLength);
  return cl;
};

char *TlvObjectERROR::get_optionalErrorSpecificInformation()
{
  char *cl = new char[sizeof(con->optionalErrorSpecificInformation)];
  strcpy(cl,con->optionalErrorSpecificInformation);
  return cl;

};


// --------------------------------- object  NSLP ------------------------------
//------------------------------------------------------------------------------


TlvObjectNSLP::TlvObjectNSLP(char* cont)
{
  int cl;
  cl = sizeof(struct objheader) + sizeof(struct construct);
  contents = new unsigned char[cl];
  header = (objheader *)contents;
  con = (construct *)(contents + sizeof(struct objheader));
  header->conlength = cl;
  header->aFlag = 0;
  header->bFlag = 0;
  header->conlength = cl;
  header->length = 32 + 8 * strlen(cont);
  header->type = TYPE_NSLP_DATA;
  con->NSLP = new char [strlen(cont)+1];
  strcpy(con->NSLP, cont);
}

char *TlvObjectNSLP::getNSLP() {
	//char *cl = new char [strlen(con->NSLP)+1];
	//strcpy(cl, con->NSLP);
	//return cl;
	return con->NSLP;
} 