/***************************************************************************
 *   Copyright (C) 2005 by Ribeiro, Romulo Eugenio                         *
 *   romulo@dei.uc.pt                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef ns_nsis_h
#define ns_nsis_h
#include "packet.h"
#include "ip.h"
#include "agent.h"
#include "address.h"
#include "adc.h"
#include "gimps.h"
#include "nsis-link.h"
#include "tcp.h"
#include "app.h"
 
class NSLPApp;							//forward declarion

class NSLPApp_Timer: public TimerHandler
{
public:
  NSLPApp_Timer(NSLPApp *app): TimerHandler()
  {
    app_= app;
  };
protected:
  NSLPApp *app_;
  virtual void expire(Event *e);
};

struct session
{
  session() : src(0), dst(0),  flowid(0), next(0) { };
  ~session() {  };
  int sid;
  nsaddr_t src;
  nsaddr_t dst;
  session *next;
  session *t_next;
  int flowid;
};

class NSLPmessage;						//forward declarion
class GIMPSAgent;						//forward declarion

class NSLPApp : public Application 
{
  friend class NSLPApp_Timer; //timer for sending package and send refresh message
  
  public:

  NSLPApp();
  int command(int argc, const char*const* argv);
  char give(Packet *p, NSISChecker *ret);
  void recvnslp(NSLPmessage *datagimps);
  void refresh();
  void executecmd(char *cmd, nsaddr_t from);
  void list_sessions_agent();
  int  refresh_;
  int nslpid_;
  GIMPSAgent *gimps_;
 
protected:
  void reset_NSLPApp_Timer();
  NSLPApp_Timer NSLP_timer_;							//timer for refresh message and send
  int  new_session_sid(nsaddr_t src, nsaddr_t dst, int fid);
  NSLPmessage *find_session_sid(int ssession );
  int sendMessage(int session, char *data);
  char * last_data;
  int last_session;
  session *session_nslp;
 
};


#endif
